
#ifndef __GRIDMAP_H__
#define __GRIDMAP_H__

#include <unistd.h>
#include <sys/types.h>

typedef struct _gridmap
{
	void *gridmap;
	void *zero;
	double size;
	int width;
	int height;
	struct _cache{
		float orient;
		float length;
	} *cache;
	size_t elm_size;
	struct _origin{
		double x;
		double y;
		double theta;
		float cos;
		float sin;
		int ix;
		int iy;
	} origin;
} gridmap;

gridmap *gm_init( int width, int height, double resoluion, size_t elm_size, void *zero );
void gm_free( gridmap *gm );
void gm_clear( gridmap *gm );
void gm_set_origin( gridmap *gm, double x, double y, double theta );
void *gm_element( gridmap *gm, float x, float y );
void *gm_element_direct( gridmap *gm, int ix, int iy );
void gm_get_location( gridmap *gm, float *x, float *y, int ix, int iy );

void gm_scan_polar( gridmap *gm, float *scan_data, int len, int (*cross) (void *) );
void gm_linear_scan( gridmap *gm, float x1, float y1, float x2, float y2, int (*scan) (void *, float, void *), void *userdata );

void gm_addressing_normalize( gridmap *gm, int *x1, int *y1 );
int  gm_addressing( gridmap *gm, float x, float y, int *ix, int *iy );


#endif
